from tkinter import*
from random import*
from time import*  

Space_Game=Tk()    ### Création d'une fenêtre
Space_Game.title("Pingame")
Space_Game.geometry("990x725")
jeu=Canvas(Space_Game,width=990,height=675)

photo=PhotoImage(file="img/Fond_espace.png")    ### Mise en place du fond
fond=jeu.create_image(495,337.5,image=photo)

vaisseau=PhotoImage(file="img/Vaisseau1.png")    ### Création du vaisseau
vaisseau_aff=jeu.create_image(495,600,image=vaisseau)

x_vaisseau=498    ### Coordonnées initiales du vaisseau
y_vaisseau=534

missile=PhotoImage(file="img/Missile1.png")   ### Définition des images correspondant aux météorites et aux punaises
punaise=PhotoImage(file="img/Punaise.png")

id_missile=list()   ### Référencement des météorites et de leurs coordonnées dans des listes
x_missile=list()
y_missile_init=50
y_missile=list()

y_punaise_init=600   ### Référencement des punaises et de leurs coordonnées dans des listes
x_punaise=list()
id_punaise=list()
y_punaise=list()

etat_punaise=list()    ### Référencement des états des météorites et des punaises
etat_missile=list()

nombre_vies=3          ### Initialisation du nombre de vies et de collisions au déjut du jeu
nombre_collisions=0

vitesse_max_punaise=10           ### Définition des vitesses de création et de déplacement des objets
vitesse_max_missile=5
vitesse_déplacement_vaisseau=15
vitesse_création_missile=2000
vitesse_création_punaise=500

def afficher_vies():   ### Fonction qui compte le nombre de vies et qui l'affiche en temps réel au dessus de la fenêtre de jeu
    global nombre_vies
    Vies=Label(text="Nombre de vies restantes :"+str(nombre_vies))
    Vies.place(x=25,y=2.5)
    Space_Game.after(10,afficher_vies)

def déplacer(event):  ## Déplacer le vaisseau
    global x_vaisseau,vitesse_déplacement_vaisseau
    if event.keysym=="Right":
        jeu.move(vaisseau_aff,vitesse_déplacement_vaisseau,0)  ## Déplace le vaisseau à droite
        x_vaisseau+=15
    if event.keysym=="Left":
        jeu.move(vaisseau_aff,-vitesse_déplacement_vaisseau,0) ## Déplace le vaisseau à gauche
        x_vaisseau-=15

jeu.bind_all("<Key>",déplacer) ## Associe la touche à la fonction déplacer

def créer_missile():
    global x_missile,id_missile,y_missile,etat_missile,vitesse_création_missile, nombre_vies
    x_missile_init=randint(0,990)      ### Choisit une valeur en x aléatoire
    x_missile.append(x_missile_init)     ### Cette valeur est donc immédiatement envoyée dans la liste stockant les coordonnées de la météorite
    img1=jeu.create_image(x_missile_init,50,image=missile)    ### Création d'un missile avec les coordonnées en x définies au dessus
    id_missile.append(img1)    ### Cette météorite est alors référencée dans une liste
    y_missile.append(y_missile_init) ### L'ordonnée de la météorite est alors elle aussi référencée dans une liste pour la connaitre en temps réel lorsqu'elle est en mouvement
    etat_missile.append("NORMAL")    ### On choisit de mettre un état à la météorite qui permettra de détecter ou non une collision
    if nombre_vies==0:
        return     ### Stoppe la fonction lorsqu'il n'y a plus de vie
    Space_Game.after(vitesse_création_missile,créer_missile)    ### Répétition de cette fonction toutes les "vitesse_création_missile" ms

def deplacer_missile():
    global y_missile_init,x_vaisseau,x_missile,y_vaisseau,nombre_vies,vaisseau_aff,id_missile,id_punaise
    for i in range(0,len(id_missile)):
        if y_missile[i]<732: ### Lorsque la météorite se trouve hors de la fenêtre, 
            jeu.move(id_missile[i],0,vitesse_max_missile)   ### On la déplace de "vitesse_max_missile" pixels
            y_missile[i]+=vitesse_max_missile   ### On change donc la valeur de l'ordonnée de la météorite
        if y_vaisseau+150>y_missile[i]>y_vaisseau and x_vaisseau-30<x_missile[i]<x_vaisseau+30:
            if etat_missile[i]=="NORMAL":   ### Lorsque la collision entre le vaisseau et la météorite est détectée, leurs états changent
                etat_missile[i]="HIDDEN"
                jeu.delete(vaisseau_aff)   ### On supprime le vaisseau et on enlève une vie
                nombre_vies-=1
                if nombre_vies!=0:   # Lorsqu'il reste des vies, on stoppe le jeu une demie seconde et on recrée un vaisseau avec les coordonnées de l'ancien
                     Space_Game.after(500)
                     vaisseau_aff=jeu.create_image(x_vaisseau,y_vaisseau+64,image=vaisseau)
                if nombre_vies==0:
                    Space_Game.after(1000) ### Attend une seconde puis ferme la fenêtre
                    Space_Game.destroy()
                    return     ### Stoppe la fonction lorsqu'il n'y a plus de vie
    Space_Game.after(30,deplacer_missile)

def créer_punaise():
    global x_punaise,y_punaise_init,punaise,id_punaise,y_punaise,etat_punaise,vaisseau_aff,vitesse_création_punaise, nombre_vies
    x_punaise_init=x_vaisseau-3   ### L'abscisse de la punaise est définie en fonction de celle du vaisseau
    x_punaise.append(x_punaise_init)   ### On référence son abscisse dans une liste
    img2=jeu.create_image(x_punaise_init,y_punaise_init,image=punaise)   ### On crée la punaise
    id_punaise.append(img2)   ### Chaque punaise est référencée dans une liste
    y_punaise.append(y_punaise_init) ### On ajoute son ordonnée dans la liste correspondante
    etat_punaise.append("NORMAL")  ### On définit son état
    jeu.tag_raise(vaisseau_aff) ### Place la punaise en arrière plan
    if nombre_vies==0:
        return     ### Stoppe la fonction lorsqu'il n'y a plus de vie
    Space_Game.after(vitesse_création_punaise,créer_punaise)
    

def deplacer_punaise():   ### Fonction qui permet de déplacer toutes les punaises
    global i,id_punaise,vitesse_max_punaise,y_punaise,y_missile,x_punaise,x_missile,id_missile,nombre_collisions,vitesse_déplacement_vaisseau,vitesse_création_punaise,vitesse_création_missile,nombre_vies
    for j in range(0,len(id_punaise)):
        if etat_punaise[j]=="NORMAL":  ### La punaise doit être à l'état normal pour être déplacée de "vitesse_max_punaise" pixels
            jeu.move(id_punaise[j],0,-vitesse_max_punaise)
            y_punaise[j]-=vitesse_max_punaise   ### L'ordonnée de la punaise est modifiée dans la liste
            for i in range(0,len(id_missile)):
                if y_punaise[j]+123>y_missile[i]>y_punaise[j]-123 and x_missile[i]-35<x_punaise[j]<x_missile[i]+35 and etat_punaise[j]=="NORMAL" and etat_missile[i]=="NORMAL":
                    jeu.delete(id_punaise[j])   ### Lorsqu'il y a collision entre la punaise et une météorite, on les supprime
                    jeu.delete(id_missile[i])
                    etat_punaise[j]="HIDDEN"   ### Les états des deux objets changent donc et on ajoute une collision au compteur
                    etat_missile[i]="HIDDEN"
                    nombre_collisions+=1
                    if nombre_collisions%10==0:   ### Lorsque le nombre de collisions est un multiple de 10, 
                        vitesse_déplacement_vaisseau+=1   ### Le vaisseau se déplace d'un pixel de plus,
                        vitesse_création_punaise-=2     ### La météorite et la punaise sont créées deux ms plus vite
                        vitesse_création_missile-=2
            if nombre_vies==0:
                return     ### Stoppe la fonction lorsqu'il n'y a plus de vie
    Space_Game.after(50,deplacer_punaise)
        
  
##Boucle principale
jeu.place(x=0,y=25)
afficher_vies()
créer_missile()
deplacer_missile()
créer_punaise()
deplacer_punaise()
Space_Game.mainloop()
